<?php
/**
 * Created by PhpStorm.
 * User: nwanasinghe
 * Date: 14/12/2016
 * Time: 10:33
 */

namespace Drupal\youtubeapi\Tests;


class Generates {

  public static function ytapi_makefiles_main() {
    //URL Ex: https://developers.google.com/youtube/v3/docs/search/list
    $file_class = DRUPAL_ROOT . '/' . drupal_get_path('module', 'myx') . '/src/Lib/legancy/simple_html_dom.php';
    $file_dir = DRUPAL_ROOT . '/' . drupal_get_path('module', 'youtubeapi') . '/files/sources';
    if (file_exists($file_class)) {
      require_once($file_class);

      $files = file_scan_directory($file_dir, '/()/', ['nomaskxx' => 1], 0);
      foreach ($files as $file) {
        self::ytapi_makefiles_exec($file, $file_dir . '/../outs');
        //break;
      }
      //echo count($files);
      //foreach ($files as $file_name) {
      //}


    }


  }


  private static function ytapi_makefiles_exec($file, $dir = '') {

    //dpm($file_html);
    //dpm("YYY");
    $uri = $file->uri;
    $filename = $file->filename;
    $name = $file->name;
    $class_name = "Youtube" . ucwords($file->name); //Human readable

    $html = file_get_html($uri);
    $elements = (($html->find(".devsite-table-wrapper tbody tr")));
    //$elements = $html->find(".devsite-table-wrapper .details tbody tr");
    //$elements = $html->find(".devsite-table-wrapper")[0]->find("tbody tr");
    //$elements = $html->find(".devsite-table-wrapper")[0]->find("tbody tr");
    // echo count($elements)." : $name\n";
    //return;

    $request_uri = "https://www.googleapis.com/youtube/v3/" . $name;
    $cpt = 0;
    $date_string = date("Y-m-d H:i:s");
    $out_yml = "";
    $out_class = "";
    $out_yml .= "#Youtube API Settings.";
    $out_yml .= "\n#Generated on : $date_string";
    $out_yml .= "\n";
    $out_yml .= "\nmethod: $name";
    $out_yml .= "\n\n#Request Parameters";
    $out_yml .= "\nrequest_uri: $request_uri";

    //Id list file
    $ids_list = [];

    //Request Details
    $out_yml .= "\nrequest:";

    //Class file
    $out_class .= <<<TEXT
<?php
/**
 *  Youtube API Class.
 *  Generated on : $date_string
 */

namespace Drupal\youtubeapi\YoutubeAPI;

/**
 *  $class_name.
 */
class $class_name extends API {

  //API URL
  const request_uri = "$request_uri";
  //API URL Part.
  const method = "$name";

  //Request Parameters.
TEXT;

    //Non initialized vars for each IDs
    $required = FALSE;

    foreach ($elements as $element) {
      $id = ($element->id);
      $apitype = "";
      $default = "";
      $multiple = FALSE;
      $isarray = FALSE;
      $options = [];

      if ($id) {
        //dpm($id);
        $elts_t = (($element->find(".apitype")));
        if (isset($elts_t[0]->plaintext)) {
          $apitype = trim(strip_tags($elts_t[0]->plaintext));
        }

        $elts_t = (($element->find("td")));
        if (isset($elts_t[1]->plaintext)) {
          $temp = $elts_t[1]->plaintext;
          if (strstr($temp, 'comma-separated') !== FALSE) {
            $multiple = "true";
          }
        }

        if (strstr($id, "[]") !== FALSE) {
          $id = str_replace("[]", "", $id);
          $isarray = TRUE;
        }
      }
      if ($id == "kind") {
        //echo "\nOK : $name";
        //return;

        //Response details
        $out_yml .= "\n\n#Response Parameters";
        $out_yml .= "\nresponse:";
        $out_class .= "\n\n  //Response Parameters ";
      }


      if ($apitype) {

        //dpm("$cpt : $id -> $apitype ");

        $elts_t = (($element->find("td ul li")));
        if ($elts_t) {
          $cpt++;
          foreach ($elts_t as $elt_t) {
            if ($elt_t->plaintext) {
              $option = strip_tags($elt_t->find("code")[0]->plaintext);
              //                $desc = strip_tags($elt_t->plaintext);
              //                if (strstr($desc, '-') !== FALSE) {
              //                  $desc = substr($desc, strpos($desc, '-'));
              //                  $desc = trim($desc);
              //                }
              //                else {
              //                  $desc = "";
              //                }
              if ($option) {
                //$options[$option] = $desc;
                // $options[] = $desc;
                $options[] = $option;
              }
            }
          }
          //dpm($options);
          //kint($options);
        }


        //Particular changes
        if ($id === 'part') {
          if (!$options) {
            $options[] = "id";
            $options[] = "snippet";
          }
          if (!$multiple && count($options) > 1) {
            $multiple = TRUE;
          }
        }
        //Set default value if array and required
        if ($required && $options) {
          if (in_array('id', $options)) {
            $default = 'id';
          }
          else {
            $default = array_shift(array_values($options));
          }
        }
        //echo "\n -- > $id";
      }
      else {
        //Meta tags
        //echo "\n ID = $id";
        if ($id === 'required-parameters') {
          $required = TRUE;
        }
        else {
          $required = FALSE;
        }
      }


      //Fill Files data
      if ($id && $apitype) {
        //Yml file
        $out_yml .= "\n  $id:";
        $out_yml .= "\n    apitype: $apitype";
        if ($options) {
          $out_yml .= "\n    options:";
          foreach ($options as $option) {
            $out_yml .= "\n      - $option";
          }
        }
        if ($default) {
          $out_yml .= "\n    default: $default";
        }
        if ($multiple) {
          $out_yml .= "\n    multiple: true";
        }
        if ($isarray) {
          $out_yml .= "\n    isarray: true";
        }
        if ($required) {
          $out_yml .= "\n    required: true";
        }

        //Class file
        $id_safe = str_replace('.', '_', $id);
        if (isset($ids_list[$id_safe])) {
          $out_class .= "\n  //const $id_safe = '$id';//Also exist here";
        }
        else {
          $out_class .= "\n  const $id_safe = '$id';";
        }
        $ids_list[$id_safe] = $id_safe;
      }

    }

    //Finalize files
    $out_class .= "\n\n}\n";

    //dpm($cpt);

    //echo($out_yml);
    //exit;
    if ($dir) {
      //Write files
      file_put_contents($dir . "/" . $name . ".yml", $out_yml);
      file_put_contents($dir . "/" . $class_name . ".php", $out_class);
    }

    echo "\nEND : $name";
  }
}